// -------------------------------------------------------------
// MYENGINE3D v2008.2.20 by Georgy Moshkin
// licence: public domain
// -------------------------------------------------------------

// Notes:
// Set DebugOutput=true in mydepthcollision.pas to see more debug
// Set UseSavedData=false in example.pas to re-calculate z-buffer data
// Uncomment gluLookAt(px,py,pz,
//                     px,py-1,pz,1,0,0) to see more debug data
// Comment  "if not ( (area_i=zonei)and(area_j=zonej)and(area_k=zonek) ) then continue"
// in mydepthcollision.pas to see more debug data"
//
// alpha-release demo



program example;

uses
  windows,sysutils,
  opengl,exgine,
  mygameobjects,
  mydepthcollision,
  mybounds,
  mycollisiontrick;

var
  ObjectBounds3d:TBounds;

  ccc:TOldVersionCollisionCircle;
  px,py,pz:single;
  sx,sy,sz:single;

  phi:single;
  ox,oy,oz:single;

// time between frames calculation vatiables
var    oldTime,newTime,elapsedTime:Integer;

var FirstRun:boolean=true;


var UseSavedData:boolean;
// -=( called every frame )=-
procedure Update;
begin
  // Exit when ESC pressed (key code 27)
  if inp.Down(27) then eX.Quit;

end;


procedure KeybMove;
begin

  if inp.Down(VK_UP) then
   begin
    sx:=sx+30*cos(phi*3.14/180)*(elapsedTime/1000);
    sz:=sz+30*sin(phi*3.14/180)*(elapsedTime/1000);
   end;
  if inp.Down(VK_DOWN) then
   begin
    sx:=sx-30*cos(phi*3.14/180)*(elapsedTime/1000);
    sz:=sz-30*sin(phi*3.14/180)*(elapsedTime/1000);
   end;

  if inp.Down(VK_LEFT) then phi:=phi-200*(elapsedTime/1000);
  if inp.Down(VK_RIGHT) then phi:=phi+200*(elapsedTime/1000);
end;



procedure Render;
var i:integer;
begin
  glClearColor(0.3,0.3,0.3,1);
  ogl.Clear(true, true); // clear opengl buffers

  glEnable(GL_DEPTH_TEST);

  OldTime:=NewTime;
  NewTime:=ex.GetTime;
  elapsedTime:=NewTime-oldTime;

  if elapsedTime>25 then elapsedTime:=25;
  if elapsedTime=0 then elapsedTime:=1;

  KeybMove;


  ogl.Set3D(70, 0.1, 500); // set 3d mode

//  glTranslatef(0,0,-350);
//  glRotatef(ex.GetTime/1000,0,1,0);

gluLookAt(px-15*cos(phi*3.14/180),py+3,pz-15*sin(phi*3.14/180),
          px,py,pz,0,1,0);

glDisable(GL_TEXTURE_2D);
   glBegin(GL_LINE_LOOP);
   for i:=0 to 11 do
    begin
     glVertex3f(Px+3*cos(30*i*3.14/180),
                Py,
                Pz+3*sin(30*i*3.14/180));
    end;
   glEnd;

   glBegin(GL_LINES);
     glVertex3f(px,
                py,
                pz);
     glVertex3f(px+3*cos(phi*3.14/180),
                py,
                pz+3*sin(phi*3.14/180));
   glEnd;
          

//gluLookAt(px,py+35,pz,
//          px,py+35-1,pz,1,0,0);



  if firstrun then
   begin

   if fileexists('!test24b!.raw') then UseSavedData:=true;

   if not UseSavedData then
    begin
     repeat
      glEnable(GL_CULL_FACE);
      BeforeRender;
      elapsedTime:=1;
      renderGameObj(0,0,elapsedTime);
     until AfterRender;
     glViewport(0, 0, 640,480);
     SaveData('!test24b!.raw',ObjectBounds3d);
    end
    else LoadData('!test24b!.raw',ObjectBounds3d);
     firstrun:=false;

   end;



  renderGameObj(0,0,elapsedTime);


  tex.Disable;

//  for i:=1 to 10 do
  DoCollisionEngine(ccc,elapsedTime/1000,sx,sy,sz,ox,oy,oz);
  FixPosition(px,py,pz,sx,sy,sz,1,elapsedTime/1000);
//  py:=sy;


//  ox:=px; {oy:=py;} oz:=pz;

  RenderBounds(ObjectBounds3d);

  glColor3f(1,1,1);

  ogl.Set2D(0, 0, wnd.Width, wnd.Height);
  tex.Disable();
  glColor3f(1, 1, 1);


  ogl.TextOut(0, 8, 16, 'CDNR2ALPHA demo v2008.2.5 (Delphi/OpenGL) by Georgy Moshkin');
  ogl.TextOut(0, 8, 32, 'Collision detection and response using z-buffer images');
  ogl.TextOut(0, 8, 32+1*16, 'Download full source code at HTTP://WWW.IGRODEL.RU/');

end;


// -=( Our program )=-
begin

  // create new window
  wnd.Create('CDNR2ALPHA demo v2008.2.5 (Delphi/OpenGL) by Georgy Moshkin');

  // give procedure pointers to exgine
  eX.SetProc(PROC_UPDATE, @Update);
  eX.SetProc(PROC_RENDER, @Render);

  // write to log files
  log.Print('Hello World!');

  inp.MCapture(true); // enable mouse "capture"

  // set window params
  wnd.Mode(False, 640, 480, 32, 75);


  loadGameObj('kat1.nft');
  ScaleObject(0,1/5);
//  TransObject(0,115,-125,15);

  getObjectBounds(0,ObjectBounds3d);
  fixObjectBounds(ObjectBounds3d);

  DepthCollisionUseBounds(ObjectBounds3d);
  MakeCollisionCircle(TestCircle);

  randomize;

  if random(100)<50 then
   begin
    sx:=-71;
    sy:=27;
    sz:=-82;
    phi:=67.5;
   end
    else
   begin
    sx:=62;
    sy:=-82;
    sz:=29;
    phi:=227;
   end;

  glEnable(GL_CULL_FACE);

  // Execute main loop
  eX.MainLoop(50);

end.

