// -------------------------------------------------------------
// MYENGINE3D v2008.2.20 by Georgy Moshkin
// licence: public domain
// -------------------------------------------------------------

program example;

uses
  windows,
  opengl,exgine,
  mygameobjects;

  var AnimIndex:integer=0;

// -=( called every frame )=-
procedure Update;
begin
  // Exit when ESC pressed (key code 27)
  if inp.Down(27) then eX.Quit;

  // Change animation index with +/- keys
  if inp.Down(VK_ADD) then inc(AnimIndex);
  if inp.Down(VK_SUBTRACT) then dec(AnimIndex);
  inp.Reset; // clear keyboard state for onKeyDown simulation

  if AnimIndex>getActionsCount(0)-1 then AnimIndex:=getActionsCount(0)-1;
  if AnimIndex<0 then AnimIndex:=0;

end;

// time between frames calculation vatiables
var    oldTime,newTime,elapsedTime:Integer;

// -=( rendering procedure )=-
procedure Render;
begin
  glClearColor(0.3,0.3,0.3,1);
  ogl.Clear(true, true); // clear opengl buffers

  glEnable(GL_DEPTH_TEST);

  OldTime:=NewTime;
  NewTime:=ex.GetTime;
  elapsedTime:=NewTime-oldTime;

  ogl.Set3D(45, 0.1, 512); // set 3d mode
  glTranslatef(0,-3,-10);
  glRotatef(-90,1,0,0);
  glRotatef(45,0,0,1);


  // render #0 horce.nft
  renderGameObj(0,AnimIndex,elapsedTime);

  tex.Disable();
  glDisable(GL_DEPTH_TEST);
  renderBones(0); // RENDER #0 MODEL BONES


  glEnable(GL_DEPTH_TEST);
  ogl.Set3D(45, 0.1, 512); // set 3d mode
  glTranslatef(5,-5,-20);

  // render #1 dance.nft
  renderGameObj(1,0,elapsedTime);

  tex.Disable();
  glDisable(GL_DEPTH_TEST);
  renderBones(1); // RENDER #1 MODEL BONES




  glColor3f(1,1,1);

  ogl.Set2D(0, 0, wnd.Width, wnd.Height);
  tex.Disable();
  glColor3f(1, 1, 1);


  ogl.TextOut(0, 8, 16, 'BLENDER NFT LOADER v2008.1.14 (Delphi/OpenGL)');
  ogl.TextOut(0, 8, 32, 'Source code by Georgy Moshkin');

  ogl.TextOut(0, 8, 32+3*16, '-= Keyboard controls =-');
  ogl.TextOut(0, 8, 32+4*16, 'Change action number: [+ / -]');
  ogl.TextOut(0, 8, 32+5*16, PChar('Model #0 action index: '+IntToStr(AnimIndex)) );
  ogl.TextOut(0, 8, 32+6*16, 'Model #1 action index: 0');

end;


// -=( Our program )=-
begin

  // create new window
  wnd.Create('BLENDER NFT LOADER v2008.1.14 (Delphi/OpenGL)');

  // give procedure pointers to exgine
  eX.SetProc(PROC_UPDATE, @Update);
  eX.SetProc(PROC_RENDER, @Render);

  // write to log files
  log.Print('Hello World!');

  inp.MCapture(true); // enable mouse "capture"

  // set window params
  wnd.Mode(False, 640, 480, 32, 75);


  loadGameObj('horce.nft'); // LOAD 3D MODEL WITH ANIMATIONS
  loadGameObj('dance.nft');  

  // Execute main loop
  eX.MainLoop(50);

end.

