// -------------------------------------------------------------
// MYENGINE3D v2008.2.20 by Georgy Moshkin
// licence: public domain
// -------------------------------------------------------------
unit mybounds;

interface

uses myvectors;

type TBounds=record
              minx,miny,minz,
              maxx,maxy,maxz:single;
             end;

type TBoundOffset=record
                   x,y,z:single;
                  end;

procedure BeforeGetMeshBounds(transverts:TVectors;var bound3d:TBounds);
procedure GetMeshBounds(transverts:TVectors;var bound3d:TBounds);
function GetCenterOffset(bound3d:TBounds):TBoundOffset;                  

implementation


procedure BeforeGetMeshBounds(transverts:TVectors;var bound3d:TBounds);
begin

with bound3d do
 begin
  minx:=transverts[0].x;
  maxx:=minx;

  miny:=transverts[0].y;
  maxy:=minz;

  minz:=transverts[0].z;
  maxz:=minz;
 end;
end;

procedure GetMeshBounds(transverts:TVectors;var bound3d:TBounds);
var i:integer;
begin

 with bound3d do
 for i:=0 to length(transverts)-1 do
  begin
   if transverts[i].x<minx then minx:=transverts[i].x;
   if transverts[i].x>maxx then maxx:=transverts[i].x;

   if transverts[i].y<miny then miny:=transverts[i].y;
   if transverts[i].y>maxy then maxy:=transverts[i].y;

   if transverts[i].z<minz then minz:=transverts[i].z;
   if transverts[i].z>maxz then maxz:=transverts[i].z;
  end;

end;


function GetCenterOffset(bound3d:TBounds):TBoundOffset;
begin
 result.x:=(bound3d.minx+bound3d.maxx)/2;
 result.y:=(bound3d.miny+bound3d.maxy)/2;
 result.z:=(bound3d.minz+bound3d.maxz)/2;

end;




end.
