// -------------------------------------------------------------
// MYENGINE3D v2008.2.20 by Georgy Moshkin
// licence: public domain
// -------------------------------------------------------------
unit mygameobjects;

interface

uses myskeletons,
     mymodels,
     mytextures,
     myrender,
     myvectors,
     mybounds,
     math;

type TGameObject=record
                  modelIndex      : integer;
                  loadedFromIndex : integer;

                  skelState       : TSkeletonState;

                  collideWithObjects : array of integer;

                 end;

type TGameObjects = array of TGameObject;                 

var Models:TModels;
    Textures:TTextures;
    gameObjects:TGameObjects;

function loadGameObj(filename:string):integer;
procedure renderBones(index:integer);
procedure renderGameObj(index,animindex:integer;elapsed:single);
function getActionsCount(index:integer):integer;
procedure GetObjectBounds(index:integer;var bound3d:TBounds);


procedure ScaleMesh(var transverts:TVectors; factor:single);
procedure ScaleObject(index:integer;factor:single);

procedure TransMesh(var transverts:TVectors; tx,ty,tz:single);
procedure TransObject(index:integer;tx,ty,tz:single);

procedure renderBounds(bound3d:TBounds);
implementation



function getActionsCount(index:integer):integer;
begin
result:=length(models[gameobjects[index].modelIndex].skAnimations.actions)
end;

function loadGameObj(filename:string):integer;
var k:integer;
begin
k:=length(gameObjects);
setlength(gameObjects,k+1);
gameObjects[k].modelIndex:=loadModel(filename,
                                     models,
                                     textures);
result:=k;
end;

procedure renderBones(index:integer);
begin
DrawBones(gameobjects[index].skelState.currentPose,
          models[gameobjects[index].modelIndex].skAnimations.skeleton);
end;

procedure renderGameObj(index,animindex:integer;elapsed:single);
var i:integer;
begin


{?}if length(models[gameobjects[index].modelIndex].skAnimations.skeleton)>0 then
Anim(models[gameobjects[index].modelIndex].skAnimations.actions,
     gameobjects[index].skelState,
     animindex,
     elapsed);


{?}if length(models[gameobjects[index].modelIndex].skAnimations.skeleton)>0 then
BuildFrame(gameobjects[index].skelState.currentPose,
           models[gameobjects[index].modelIndex].skAnimations.skeleton);



{?}if length(models[gameobjects[index].modelIndex].skAnimations.skeleton)>0 then
for i:=0 to length(models[gameobjects[index].modelIndex].Meshes)-1 do
  Transform(models[gameobjects[index].modelIndex].Meshes[i].transVerts,
            models[gameobjects[index].modelIndex].Meshes[i].restVerts,
            models[gameobjects[index].modelIndex].Meshes[i].vertsParents,
            gameobjects[index].skelState.currentPose,
            models[gameobjects[index].modelIndex].skAnimations.reference,
            models[gameobjects[index].modelIndex].skAnimations.skeleton);


for i:=0 to length(models[gameobjects[index].modelIndex].Meshes)-1 do
      DrawPolys(models[gameobjects[index].modelIndex].Meshes[i].polygons,
                models[gameobjects[index].modelIndex].Meshes[i].transVerts);

end;

procedure renderBounds(bound3d:TBounds);
begin
 DrawBounds(bound3d,GetCenterOffset(bound3d));
end;


procedure ScaleMesh(var transverts:TVectors; factor:single);
var i:integer;
begin
 for i:=0 to length(transverts)-1 do
  begin
   transverts[i].x:=transverts[i].x*factor;
   transverts[i].y:=transverts[i].y*factor;
   transverts[i].z:=transverts[i].z*factor;
  end;
end;


procedure ScaleObject(index:integer;factor:single);
var i:integer;
begin
for i:=0 to length(models[gameobjects[index].modelIndex].Meshes)-1 do
 ScaleMesh(models[gameobjects[index].modelIndex].Meshes[i].transVerts,
           factor);
end;


procedure TransMesh(var transverts:TVectors; tx,ty,tz:single);
var i:integer;
begin
 for i:=0 to length(transverts)-1 do
  begin
   transverts[i].x:=transverts[i].x+tx;
   transverts[i].y:=transverts[i].y+ty;
   transverts[i].z:=transverts[i].z+tz;
  end;
end;

procedure TransObject(index:integer;tx,ty,tz:single);
var i:integer;
begin
for i:=0 to length(models[gameobjects[index].modelIndex].Meshes)-1 do
 TransMesh(models[gameobjects[index].modelIndex].Meshes[i].transVerts,
           tx,ty,tz);
end;



procedure GetObjectBounds(index:integer;var bound3d:TBounds);
var i:integer;
begin

BeforeGetMeshBounds(models[gameobjects[index].modelIndex].Meshes[0].transVerts,
                    bound3d);

                    for i:=0 to length(models[gameobjects[index].modelIndex].Meshes)-1 do
 GetMeshBounds(models[gameobjects[index].modelIndex].Meshes[i].transVerts,
               bound3d);


end;



end.
