// -------------------------------------------------------------
// MYENGINE3D v2008.2.20 by Georgy Moshkin
// licence: public domain
// -------------------------------------------------------------
unit myrender;

interface

uses OpenGL,myvectors,mypolygons,mymeshes,myskeletons,mybounds,
     exgine;

procedure DrawPoints(points:TVectors);
procedure DrawPolysWire(polys:TPolygons;transverts:TVectors);
procedure DrawNormals(polys:TPolygons;transverts:TVectors);
procedure DrawPolys(polys:TPolygons;transverts:TVectors);
procedure DrawNodes(Pose:TAnimFrame);
procedure DrawBones(Pose:TAnimFrame;Skel:TSkeleton);

procedure DrawBounds(bound3d:TBounds;offset3d:TBoundOffset);

implementation

procedure DrawPoints(points:TVectors);
var i:integer;
begin
 glBegin(GL_POINTS);
 for i:=0 to length(points)-1 do
  begin
   glVertex3f(points[i].x,
              points[i].y,
              points[i].z)
  end;
 glEnd;
end;

procedure DrawPolysWire(polys:TPolygons;transverts:TVectors);
var i,k:integer;
begin
for i:=0 to length(polys)-1 do
 begin
  glBegin(GL_LINE_STRIP);
  for k:=0 to 2 do
  glVertex3f(transverts[polys[i].vertIndex[k]].x,
             transverts[polys[i].vertIndex[k]].y,
             transverts[polys[i].vertIndex[k]].z);
  glEnd;
 end;

end;

procedure DrawNormals(polys:TPolygons;transverts:TVectors);
var i,k:integer;
begin
for i:=0 to length(polys)-1 do
 begin
  glBegin(GL_LINES);

  for k:=0 to 2 do
    with transverts[polys[i].vertIndex[k]] do
     begin
      glVertex3f(x,y,z);
      glVertex3f(x+polys[i].normal[k].x,
                 y+polys[i].normal[k].y,
                 z+polys[i].normal[k].z)

     end;

  glEnd;
 end;

end;

procedure DrawPolys(polys:TPolygons;transverts:TVectors);
var i,k:integer;
    curtex:longword;
begin
curtex:=0;

for i:=0 to length(polys)-1 do
 begin

   tex.Enable(polys[i].textureId,0);

   glBegin(GL_TRIANGLES);

   for k:=0 to 2 do
     begin
      glTexCoord2f(polys[i].texcoord[k].x,
                   1-polys[i].texcoord[k].y);
      glVertex3f(transverts[polys[i].vertIndex[k]].x,
                 transverts[polys[i].vertIndex[k]].y,
                 transverts[polys[i].vertIndex[k]].z);

     end;

   glEnd;


 end;

end;

procedure DrawNodes(Pose:TAnimFrame);
var i:integer;
begin

glBegin(GL_POINTS);
for i:=0 to length(pose)-1 do
 begin
  glVertex3f(pose[i].point1.x,
             pose[i].point1.y,
             pose[i].point1.z)
 end;
glEnd;


end;

procedure DrawBones(Pose:TAnimFrame;Skel:TSkeleton);
var i:integer;
begin

glBegin(GL_LINES);
for i:=0 to length(pose)-1 do
  if skel[i].parent<>-1 then
   begin
    glVertex3f(pose[i].point1.x,
               pose[i].point1.y,
               pose[i].point1.z);

    glVertex3f(pose[skel[i].parent].point1.x,
               pose[skel[i].parent].point1.y,
               pose[skel[i].parent].point1.z)
   end;

glEnd;

glPointSize(4);
DrawNodes(Pose);

end;

procedure DrawBounds(bound3d:TBounds;offset3d:TBoundOffset);
begin
 glColor3f(1,1,1);
with bound3d do
 begin
  glBegin(GL_LINES);
  glVertex3f(minx,miny,minz);
  glVertex3f(maxx,miny,minz);

  glVertex3f(maxx,miny,minz);
  glVertex3f(maxx,miny,maxz);

  glVertex3f(maxx,miny,maxz);
  glVertex3f(minx,miny,maxz);

  glVertex3f(minx,miny,maxz);
  glVertex3f(minx,miny,minz);

///

  glVertex3f(minx,maxy,minz);
  glVertex3f(maxx,maxy,minz);

  glVertex3f(maxx,maxy,minz);
  glVertex3f(maxx,maxy,maxz);

  glVertex3f(maxx,maxy,maxz);
  glVertex3f(minx,maxy,maxz);

  glVertex3f(minx,maxy,maxz);
  glVertex3f(minx,maxy,minz);

///

  glVertex3f(minx,miny,minz);
  glVertex3f(minx,maxy,minz);

  glVertex3f(maxx,miny,minz);
  glVertex3f(maxx,maxy,minz);

  glVertex3f(maxx,miny,maxz);
  glVertex3f(maxx,maxy,maxz);

  glVertex3f(minx,miny,maxz);
  glVertex3f(minx,maxy,maxz);

  glEnd;
 end;

 glLineWidth(3);

 with offset3d do
  begin
   glBegin(GL_LINES);
   glVertex3f(0,0,0);
   glVertex3f(x,y,z);   
   glEnd;
  end; 

  glLineWidth(1);
end;






end.
